<template>
  <div>
    <Row>
      <!--查询-->
      <Col span="24" />
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="100"
        class="search-form"
      >
        <label class="label-sign" />
        <Form-item class="search-item" label="培训内容:">
          <Input v-model="formObj.contentAim" placeholder="请输入培训内容" @on-enter="_formSearch" />
        </Form-item>
        <Form-item class="search-item" label="授课机构或人员:">
          <Input v-model="formObj.teachParty" placeholder="请输入授课机构或人员" @on-enter="_formSearch" />
        </Form-item>
        <Form-item class="search-item" label="实施开始时间:">
          <DatePicker
            type="daterange"
            style="width: 200px;"
            placeholder="请选择实施开始时间"
            @on-change="_dateChange"
          />
        </Form-item>
        <Form-item class="search-btn">
          <Button type="primary" @click="_formSearch">
            搜索
          </Button>
        </Form-item>
      </Form>
      </Col>
      <!--按钮-->
      <Col span="24" />
      <!--      <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />-->
      <!--      <el-button type="success" style="margin-bottom: 5px;margin-left: 5px;" @click="_add">-->
      <!--        添加-->
      <!--      </el-button>-->
      </Col>
      <!--table-->
      <Col span="24" />
      <element-table
        ref="pageTable"
        :page-columns="pageColumns"
        :table-height="tableHeight"
        :get-page="getPage"
        :opt-col-width="80"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.key"
          show-overflow-tooltip
          sortable
          :prop="item.key"
          :label="item.title"
          :width="item.width"
          :min-width="200"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <div v-if="item.dateTime">
              {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}
            </div>
            <div v-else-if="item.date">
              {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM'):'' }}
            </div>
            <span v-else-if="item.type" class="blue-color">
              {{ scope.row[item.key] === undefined ? '': scope.row[item.key].display }}
            </span>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
        <el-table-column
          slot="col"
          label="操作"
          align="center"
          :width="200"
          fixed="right"
        >
          <template slot-scope="scope">
            <icon-list
              :msg="iconMsg"
              :row-data="scope.row"
              @on-result-change="_iconClick"
            />
          </template>
        </el-table-column>
      </element-table>
      </Col>
    </Row>
    <!--添加编辑-->
    <typeEdit ref="editModal" @on-result-change="_page" />
  </div>
</template>
<script>
import { staffTrainRecord } from '../../../api'
import typeEdit from './StaffTrainRecordCheckEdit'
export default {
  components: { typeEdit },
  data() {
    return {
      formObj: {
        contentAim: '',
        teachParty: '',
        stime: '',
        etime: ''
      },
      searchOpen: true,
      btn: [],
      pageColumns: [
        { title: '培训主题', key: 'trainTopic', width: 100 },
        { title: '培训内容', key: 'trainContent', width: 180 },
        { title: '培训对象', key: 'trainObjects', width: 180 },
        { title: '人数', key: 'personQuantity', width: 80 },
        { title: '学时', key: 'learnHour', width: 80 },
        { title: '授课机构或人员', key: 'teachParty', width: 180 },
        { title: '实施开始时间', key: 'stime', width: 120, date: true },
        { title: '实施结束时间', key: 'etime', width: 120, date: true },
        { title: '培训形式', key: 'trainForm', width: 180 },
        { title: '所属培训计划', key: 'trainName', width: 180 },
        { title: '评价方式', key: 'evaluateForm', width: 180 },
        { title: '备注', key: 'remark', width: 240 },
        { title: '培训目标/目的', key: 'contentAim', width: 240 },
        { title: '培训地点', key: 'trainArea', width: 240 },
        { title: '培训有效性确认', key: 'trainEntrue', width: 240 },
        { title: '确认人', key: 'confirmor', width: 240 },
        { title: '确认时间', key: 'confirTime', width: 240, date: true }
      ],
      getPage: {},
      iconMsg: [
        { type: 'pt-a-edit', id: '', name: '编辑' },
        { type: 'pt-a-clock', id: '', name: '操作日志' }
      ],
      iconMsgDis: [
        {
          type: 'pt-a-edit',
          id: '',
          name: '编辑',
          disabled: true
        },
        { type: 'pt-a-submit', id: '', name: '提交', disabled: true },
        {
          type: 'pt-a-trash',
          id: '',
          name: '删除',
          disabled: true
        },
        { type: 'pt-a-man', id: '', name: '人员管理' },
        { type: 'pt-a-cloud', id: '', name: '查看附件' }
      ]
      // iconMsg: [
      //   { type: 'pt-a-edit', id: '', name: '编辑' },
      //   { type: 'pt-a-trash', id: '', name: '删除' }
      // ],
      // iconMsgDis: [
      //   { type: 'pt-a-edit', id: '', name: '编辑' },
      //   { type: 'pt-a-trash', id: '', name: '删除', disabled: true }
      // ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _dateChange(data) {
      this.formObj.stime = data[0]
      this.formObj.etime = data[1]
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await staffTrainRecord.page(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _searchParams(formId) {
      return this.$refs.pageTable._searchParams(formId)
    },

    _add() {
      this.$refs.editModal._open()
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
        case '提交':
          this._submit(data.id)
          break
        case '删除':
          this._deleteById(data.id)
          break
      }
    },
    _submit(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定提交该信息？',
        onOk: () => {
          this._submitOk(id)
        }
      })
    },
    _submitOk: async function(id) {
      const result = await staffTrainRecord.submitById(id)
      if (result) {
        this.$Message.success('提交成功')
        this._page()
      }
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该信息？',
        onOk: () => {
          this._delOk(id)
        }
      })
    },
    _delOk: async function(id) {
      const result = await staffTrainRecord.deleteById(id)
      if (result) {
        this.$Message.success('删除成功')
        this._page()
      }
    },
    _editModal: async function(id) {
      const result = await staffTrainRecord.getVOById(id)
      if (result) {
        this.$refs.editModal._open(result)
      }
    }
  }
}
</script>
